diff -Naur -x '*.dia' -x '*.pcap' ns-3.31/src/stats/test/histogram-test-suite.cc ns-3.32/src/stats/test/histogram-test-suite.cc
--- ns-3.31/src/stats/test/histogram-test-suite.cc	1969-12-31 16:00:00.000000000 -0800
+++ ns-3.32/src/stats/test/histogram-test-suite.cc	2020-10-06 15:35:43.000000000 -0700
@@ -0,0 +1,101 @@
+/* -*- Mode:C++; c-file-style:"gnu"; indent-tabs-mode:nil; -*- */
+//
+// Copyright (c) 2009 INESC Porto
+//
+// This program is free software; you can redistribute it and/or modify
+// it under the terms of the GNU General Public License version 2 as
+// published by the Free Software Foundation;
+//
+// This program is distributed in the hope that it will be useful,
+// but WITHOUT ANY WARRANTY; without even the implied warranty of
+// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+// GNU General Public License for more details.
+//
+// You should have received a copy of the GNU General Public License
+// along with this program; if not, write to the Free Software
+// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+//
+// Author: Pedro Fortuna  <pedro.fortuna@inescporto.pt> <pedro.fortuna@gmail.com>
+//
+
+#include "ns3/histogram.h"
+#include "ns3/test.h"
+
+using namespace ns3;
+
+/**
+ * \ingroup stats
+ * \defgroup stats-test Stats module tests
+ */
+
+/**
+ * \ingroup stats-test
+ * \ingroup tests
+ *
+ * \brief Histogram Test
+ */
+class HistogramTestCase : public ns3::TestCase {
+private:
+public:
+  HistogramTestCase ();
+  virtual void DoRun (void);
+
+
+};
+
+HistogramTestCase::HistogramTestCase ()
+  : ns3::TestCase ("Histogram")
+{
+}
+
+
+void
+HistogramTestCase::DoRun (void)
+{
+  Histogram h0 (3.5);
+  // Testing floating-point bin widths
+  {
+    for (int i=1; i <= 10; i++)
+      { 
+        h0.AddValue (3.4);
+      }
+
+    for (int i=1; i <= 5; i++)
+      {
+        h0.AddValue (3.6);
+      }
+
+    NS_TEST_EXPECT_MSG_EQ_TOL (h0.GetBinWidth (0),  3.5, 1e-6, "");
+    NS_TEST_EXPECT_MSG_EQ (h0.GetNBins (),  2, "");
+    NS_TEST_EXPECT_MSG_EQ_TOL (h0.GetBinStart (1),  3.5, 1e-6, "");
+    NS_TEST_EXPECT_MSG_EQ (h0.GetBinCount (0),  10, "");
+    NS_TEST_EXPECT_MSG_EQ (h0.GetBinCount (1),  5, "");
+  }
+
+  {
+    // Testing bin expansion
+    h0.AddValue (74.3);
+    NS_TEST_EXPECT_MSG_EQ (h0.GetNBins (), 22, "");
+    NS_TEST_EXPECT_MSG_EQ (h0.GetBinCount (21), 1, "");
+  }
+}
+
+/**
+ * \ingroup stats-test
+ * \ingroup tests
+ *
+ * \brief Histogram TestSuite
+ */
+class HistogramTestSuite : public TestSuite
+{
+public:
+  HistogramTestSuite ();
+};
+
+HistogramTestSuite::HistogramTestSuite ()
+  : TestSuite ("histogram", UNIT)
+{
+  AddTestCase (new HistogramTestCase, TestCase::QUICK);
+}
+
+static HistogramTestSuite g_HistogramTestSuite; //!< Static variable for test initialization
diff -Naur -x '*.dia' -x '*.pcap' ns-3.31/src/stats/wscript ns-3.32/src/stats/wscript
--- ns-3.31/src/stats/wscript	2020-06-27 17:38:30.000000000 -0700
+++ ns-3.32/src/stats/wscript	2020-10-06 15:35:43.000000000 -0700
@@ -11,7 +11,6 @@
     conf.report_optional_feature("SQLiteStats", "SQLite stats support",
                                  conf.env['SQLITE_STATS'] and conf.env['SEMAPHORE_ENABLED'],
                                  "library 'sqlite3' and/or semaphore.h not found")
-    conf.write_config_header('ns3/stats-config.h', top=True)
 
 def build(bld):
     obj = bld.create_ns3_module('stats', ['core'])
@@ -36,6 +35,7 @@
         'model/file-aggregator.cc',
         'model/gnuplot-aggregator.cc',
         'model/get-wildcard-matches.cc', 
+        'model/histogram.cc',
         ]
 
     module_test = bld.create_ns3_module_test_library('stats')
@@ -43,6 +43,7 @@
         'test/basic-data-calculators-test-suite.cc',
         'test/average-test-suite.cc',
         'test/double-probe-test-suite.cc',
+        'test/histogram-test-suite.cc',
         ]
 
     # Tests encapsulating example programs should be listed here
@@ -76,6 +77,7 @@
         'model/file-aggregator.h',
         'model/gnuplot-aggregator.h',
         'model/get-wildcard-matches.h',
+        'model/histogram.h',
         ]
 
     if bld.env['SQLITE_STATS']:
